/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#ifdef __GNUG__
#pragma implementation "setident.hxx"
#pragma implementation "listtempl.hxx"
#pragma implementation "listinst.hxx"
#pragma implementation "connectdinfo.hxx"
#endif

#include "set.hxx"
#include "connectdinfo.hxx"
#include "list.hxx"

SvcSocket& operator>>(SvcSocket& s, ListVal<char*>& l) 
{ 
  int size ;
  s >> size ;
  IterListVal<char*> iter(l) ;
  for (int i = 0; i < size; i++) {    
    char* el ;
    s >> el ;
    if (s.error()) return s;
    iter.insertRef(el) ;
  } 
  return s ;  
}

template class ListVal<int> ;
template class IterListVal<int> ;
template class ListVal<char*> ;
template class IterListVal<char*> ;
template class ListVal<double> ;
template class IterListVal<double> ;
template class ListVal<ServDescr> ;
template class ListVal<ConnectdInfo> ;
template class IterListVal<ServDescr> ;
template class IterListVal<ConnectdInfo> ;
template class ListPtr<ServDescr> ;
template class IterListPtr<ServDescr> ;
template class ListPtr<SvcServer> ;
template class IterListPtr<SvcServer> ;
template class ListPtr<proxy(ConnectionD)> ;
template class IterListPtr<proxy(ConnectionD)> ;

template SvcSocket& operator<<(SvcSocket&, const ListVal<int>&) ;
template SvcSocket& operator>>(SvcSocket&, ListVal<int>&) ;
template SvcSocket& operator<<(SvcSocket&, const ListVal<char*>&) ;
template SvcSocket& operator>>(SvcSocket&, ListVal<char*>&) ;
template SvcSocket& operator<<(SvcSocket&, const ListVal<double>&) ;
template SvcSocket& operator>>(SvcSocket&, ListVal<double>&) ;
template SvcSocket& operator<<(SvcSocket&, const ListVal<ServDescr>&) ;
template SvcSocket& operator>>(SvcSocket&, ListVal<ServDescr>&) ;
template SvcSocket& operator<<(SvcSocket&, const ListVal<ConnectdInfo>&) ;
template SvcSocket& operator>>(SvcSocket&, ListVal<ConnectdInfo>&) ;

